model.BL_indices=[6 7 8 10 11 12 13];% backward-looking variables indices in PLM
model.FL_indices=[3 5 6 7 9 10 11];% forward-looking  variables indices 
model.ex_FL=[1 2 4 8 12 13 14 15 16 17];
model.ex_BL=[1 2 3 4 5 9 14 15 16 17];

%forward variables 


syms RHO 

RHO = diag([rho_a rho_b rho_g rho_i rho_r rho_p rho_w ]);

%intercepts 

syms alpha_rk alpha_q alpha_c alpha_i alpha_l alpha_pi alpha_w ; 

%beta_mat, 7x7 

syms beta_11 beta_12 beta_13 beta_14 beta_15 beta_16 beta_17 ...
     beta_21 beta_22 beta_23 beta_24 beta_25 beta_26 beta_27 ...
     beta_31 beta_32 beta_33 beta_34 beta_35 beta_36 beta_37 ...
     beta_41 beta_42 beta_43 beta_44 beta_45 beta_46 beta_47 ...
     beta_51 beta_52 beta_53 beta_54 beta_55 beta_56 beta_57 ...
     beta_61 beta_62 beta_63 beta_64 beta_65 beta_66 beta_67 ... 
     beta_71 beta_72 beta_73 beta_74 beta_75 beta_76 beta_77;

 %d_mat, 7x7 
 
 syms dd_11 dd_12 dd_13 dd_14 dd_15 dd_16 dd_17 ...
     dd_21 dd_22 dd_23 dd_24 dd_25 dd_26 dd_27 ...
     dd_31 dd_32 dd_33 dd_34 dd_35 dd_36 dd_37 ...
     dd_41 dd_42 dd_43 dd_44 dd_45 dd_46 dd_47 ...
     dd_51 dd_52 dd_53 dd_54 dd_55 dd_56 dd_57 ...
     dd_61 dd_62 dd_63 dd_64 dd_65 dd_66 dd_67 ... 
     dd_71 dd_72 dd_73 dd_74 dd_75 dd_76 dd_77;
 
%convert to matrices 

alpha_mat_tmp = [alpha_rk alpha_q alpha_c alpha_i alpha_l alpha_pi alpha_w ]';

beta_mat_tmp = [beta_11 beta_12 beta_13 beta_14 beta_15 beta_16 beta_17; ...
     beta_21 beta_22 beta_23 beta_24 beta_25 beta_26 beta_27; ...
     beta_31 beta_32 beta_33 beta_34 beta_35 beta_36 beta_37; ...
     beta_41 beta_42 beta_43 beta_44 beta_45 beta_46 beta_47; ...
     beta_51 beta_52 beta_53 beta_54 beta_55 beta_56 beta_57; ...
     beta_61 beta_62 beta_63 beta_64 beta_65 beta_66 beta_67; ... 
     beta_71 beta_72 beta_73 beta_74 beta_75 beta_76 beta_77];
 
 
 dd_mat_tmp = [dd_11 dd_12 dd_13 dd_14 dd_15 dd_16 dd_17; ...
     dd_21 dd_22 dd_23 dd_24 dd_25 dd_26 dd_27; ...
     dd_31 dd_32 dd_33 dd_34 dd_35 dd_36 dd_37; ...
     dd_41 dd_42 dd_43 dd_44 dd_45 dd_46 dd_47; ...
     dd_51 dd_52 dd_53 dd_54 dd_55 dd_56 dd_57; ...
     dd_61 dd_62 dd_63 dd_64 dd_65 dd_66 dd_67; ... 
     dd_71 dd_72 dd_73 dd_74 dd_75 dd_76 dd_77];
 
% aa_tmp = alpha_mat_tmp;
% bb_tmp = beta_mat_tmp;

% aa_tmp(model.FL_indices) = alpha_mat_tmp; 
% aa_tmp(model.ex_FL) = 0;
% aa_tmp=aa_tmp';
% 
% bb_tmp(model.FL_indices,model.BL_indices) = beta_mat_tmp; 
% bb_tmp(model.ex_FL, model.ex_BL) = 0;
% 
% dd_tmp(model.FL_indices,:) = dd_mat_tmp;
% dd_tmp(model.ex_FL,:) = 0;

%if we assume t-timing: 
% plm: x_t = a + b x_{t-1} + d eps_t --> 
% expectation: x_{t+1} = a + b x_{t} + d rho eps_t 


% aa = aa_tmp + bb_tmp * aa_tmp;
% bb = bb_tmp^2;
% dd = bb_tmp * dd_tmp + dd_tmp * RHO;
% aa = aa_tmp ; 
% bb = bb_tmp; 
% dd = dd_tmp * RHO;
  

aa=alpha_mat_tmp;
bb = beta_mat_tmp;
dd=dd_mat_tmp;

%  
%  aa=aa(model.FL_indices);
%  bb=bb(model.FL_indices,model.BL_indices); 
%  dd=dd(model.FL_indices,:);
 
 %then write out the expectation equations explicitly -- 
 %this will be of the form x_t = aa + bb x_{t-1} + dd eps_t for each var. 
 
%1) rk  
exp1 = -rkp + aa(1) + ...
    bb(1,1) * c +...
 bb(1,2) * inve + ... 
 bb(1,3) * y + ... 
 bb(1,4) * pinf + ... 
 bb(1,5) * w + ... 
 bb(1,6) * r + ... 
 bb(1,7) * kp + ... 
 dd(1,1) * eps_a + ...
 dd(1,2) * eps_b + ... 
 dd(1,3) * eps_g + ... 
 dd(1,4) * eps_i + ... 
 dd(1,5) * eps_r + ... 
 dd(1,6) * eps_p + ... 
 dd(1,7) * eps_w ==0;

%2) q 

exp2 = -qp + aa(2) + ...
    bb(2,1) * c +...
 bb(2,2) * inve + ... 
 bb(2,3) * y + ... 
 bb(2,4) * pinf + ... 
 bb(2,5) * w + ... 
 bb(2,6) * r + ... 
 bb(2,7) * kp + ... 
 dd(2,1) * eps_a + ...
 dd(2,2) * eps_b + ... 
 dd(2,3) * eps_g + ... 
 dd(2,4) * eps_i + ... 
 dd(2,5) * eps_r + ... 
 dd(2,6) * eps_p + ... 
 dd(2,7) * eps_w ==0;

%3) c 

exp3 = -cp + aa(3) + ...
    bb(3,1) * c +...
 bb(3,2) * inve + ... 
 bb(3,3) * y + ... 
 bb(3,4) * pinf + ... 
 bb(3,5) * w + ... 
 bb(3,6) * r + ... 
 bb(3,7) * kp + ... 
 dd(3,1) * eps_a + ...
 dd(3,2) * eps_b + ... 
 dd(3,3) * eps_g + ... 
 dd(3,4) * eps_i + ... 
 dd(3,5) * eps_r + ... 
 dd(3,6) * eps_p + ... 
 dd(3,7) * eps_w ==0;

%4) i

exp4 = -invep + aa(4) + ...
    bb(4,1) * c +...
 bb(4,2) * inve + ... 
 bb(4,3) * y + ... 
 bb(4,4) * pinf + ... 
 bb(4,5) * w + ... 
 bb(4,6) * r + ... 
 bb(4,7) * kp + ... 
 dd(4,1) * eps_a + ...
 dd(4,2) * eps_b + ... 
 dd(4,3) * eps_g + ... 
 dd(4,4) * eps_i + ... 
 dd(4,5) * eps_r + ... 
 dd(4,6) * eps_p + ... 
 dd(4,7) * eps_w ==0;


%5) lab

exp5 = -labp + aa(5) + ...
    bb(5,1) * c +...
 bb(5,2) * inve + ... 
 bb(5,3) * y + ... 
 bb(5,4) * pinf + ... 
 bb(5,5) * w + ... 
 bb(5,6) * r + ... 
 bb(5,7) * kp + ... 
 dd(5,1) * eps_a + ...
 dd(5,2) * eps_b + ... 
 dd(5,3) * eps_g + ... 
 dd(5,4) * eps_i + ... 
 dd(5,5) * eps_r + ... 
 dd(5,6) * eps_p + ... 
 dd(5,7) * eps_w ==0;

%6) pinf

exp6 = -pinfp + aa(6) + ...
    bb(6,1) * c +...
 bb(6,2) * inve + ... 
 bb(6,3) * y + ... 
 bb(6,4) * pinf + ... 
 bb(6,5) * w + ... 
 bb(6,6) * r + ... 
 bb(6,7) * kp + ... 
 dd(6,1) * eps_a + ...
 dd(6,2) * eps_b + ... 
 dd(6,3) * eps_g + ... 
 dd(6,4) * eps_i + ... 
 dd(6,5) * eps_r + ... 
 dd(6,6) * eps_p + ... 
 dd(6,7) * eps_w  + eta_pi_exp ==0;

%7) w
exp7 = -wp + aa(7) + ...
    bb(7,1) * c +...
 bb(7,2) * inve + ... 
 bb(7,3) * y + ... 
 bb(7,4) * pinf + ... 
 bb(7,5) * w + ... 
 bb(7,6) * r + ... 
 bb(7,7) * kp + ... 
 dd(7,1) * eps_a + ...
 dd(7,2) * eps_b + ... 
 dd(7,3) * eps_g + ... 
 dd(7,4) * eps_i + ... 
 dd(7,5) * eps_r + ... 
 dd(7,6) * eps_p + ... 
 dd(7,7) * eps_w ==0;
 

